module seg_led(
	clk,
	rst_n,
	display_num,
	dtube_cs_n,
	dtube_data);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input [15:0] display_num;
	output [2:0] dtube_cs_n;
	output [7:0] dtube_data;

	wire clk;
	wire rst_n;
	wire [15:0] display_num;
	reg [2:0] dtube_cs_n;
	reg [7:0] dtube_data;

	//----Code starts here: integrated by Robei-----
	parameter CNT_MAX = 100;
	parameter 	NUM0 	= 8'b0011_1111, //0˴Ϊд
							NUM1 	= 8'b0000_0110, //1
							NUM2 	= 8'b0101_1011, //2
							NUM3 	= 8'b0100_1111, //3
							NUM4 	= 8'b0110_0110, //4
							NUM5 	= 8'b0110_1101, //5
							NUM6 	= 8'b0111_1101, //6
							NUM7 	= 8'b0000_0111, //7
							NUM8 	= 8'b0111_1111, //8
							NUM9 	= 8'b0110_1111, //9
							MIE 	= 8'h00; //ʾ
	
				
				parameter	CSN		= 3'b000,
				CS3		= 3'b111,  //λ
				CS0		= 3'b110,  //ʮλ
				CS1		= 3'b101,  //λ
				CS2		= 3'b100;  //ǧλ
				
	//ʱʾݿƵԪ
	reg[3:0] current_display_num;	//ǰʾ
	reg[1:0] div_cnt;	//ʱ
	reg [16:0] delay_cnt;
	reg delay;
	
	//delay 3ms
	always@(posedge clk or negedge rst_n)begin
			if(!rst_n)begin
					delay <= 1'b0;
					delay_cnt <= 17'd0;
			end
			else if(delay_cnt == CNT_MAX)
					delay_cnt <= 17'd0;
			else if(delay_cnt < CNT_MAX)
					delay_cnt <= delay_cnt + 1'b1;
			else
					delay_cnt <= 17'd0;
	end
	
	
		//ʱ
	always @(posedge clk or negedge rst_n)begin
			if(!rst_n) 
					div_cnt <= 2'd0;
			else if(delay_cnt==CNT_MAX) 
					div_cnt <= div_cnt+1'b1; 
	end
	
		//λѡ
	always@(posedge clk or negedge rst_n)begin
			if(!rst_n) 
					dtube_cs_n <= CSN;
			else begin
					case(div_cnt)
							2'b01: dtube_cs_n <= CS2;  
							2'b10: dtube_cs_n <= CS3;  
							2'b11: dtube_cs_n <= CS0;  
							2'b00: dtube_cs_n <= CS1; 
							default:  dtube_cs_n <= dtube_cs_n;
					endcase
			end
	end
	
	always@(posedge clk or negedge rst_n)begin
			if(!rst_n)
					current_display_num<=4'hf;
			else begin
	 				case(dtube_cs_n)
							CS0:current_display_num <= display_num[7:4];
							CS1:current_display_num <= display_num[11:8];
							CS2:current_display_num <= display_num[15:12];
							CS3:current_display_num <= display_num[3:0];   
							default:current_display_num <= current_display_num;
	 				endcase
			end
	end
	
	//ѡ
	always@(posedge clk or negedge rst_n)begin
			if(!rst_n) 
					dtube_data <= MIE;
			else begin
					case(current_display_num) 
							4'd0: dtube_data <= NUM0;
							4'd1: dtube_data <= NUM1;
							4'd2: dtube_data <= NUM2;
							4'd3: dtube_data <= NUM3;
							4'd4: dtube_data <= NUM4;
							4'd5: dtube_data <= NUM5;
							4'd6: dtube_data <= NUM6;
							4'd7: dtube_data <= NUM7;
							4'd8: dtube_data <= NUM8;
							4'd9: dtube_data <= NUM9;
							default: dtube_data <= MIE;
					endcase
			end
	end
	
	
endmodule    //seg_led

